package main

import (
	"fmt"
	"gitlab.schukai.com/oss/libraries/go/application/xflags"
	"os"
)

func main() {

	var settings *xflags.Settings[Definition]

	definition := Definition{}
	definition.Template.Prepare.DataFile = "data.yaml"

	settings = xflags.New(os.Args[0], definition)
	settings.Parse(os.Args[1:])
	settings.Execute()

	if settings.HasErrors() {
		for _, err := range settings.Errors() {
			fmt.Println(err)
		}

		os.Exit(1)
	} else {
		if settings.WasExecuted() {
			os.Exit(0)
		}
		os.Exit(1)
	}

}
